  /*********************************************************************************************
  This file is part of GeneralVehicle project
  Copyright belogs to Fred18 for module implementation and its code
  
  GeneralVehicle is distributed FREEWARE. Its code is distributed along with the dll. Nobody is authorized to exploit the module or the code or parts of them commercially directly or indirectly.
You CAN distribute the dll together with your addon but in this case you MUST:
-	Include credit to the author in your addon documentation;
-	Add to the addon documentation the official link of Orbit Hangar Mods for download and suggest to download the latest and updated version of the module.
You CAN use parts of the code of GeneralVehicle, but in this case you MUST:
-	Give credits in your copyright header and in your documentation for the part you used.
-	Let your project be open source and its code available for at least visualization by other users.
You CAN NOT use the entire code for making and distributing the very same module claiming it as your work entirely or partly.
You CAN NOT claim that GeneralVehicle is an invention of yourself or a work made up by yourself, or anyhow let intend that is not made and coded by the author.
You install and use GeneralVehicle at your own risk, author will not be responsible for any claim or damage subsequent to its use or for the use of part of it or of part of its code.
*********************************************************************************************/

 //****************************************************/

// ==============================================================
//						GeneralVehicle
//                  
//					       By Fred18
//                  
//
// GeneralVehicle.cpp
// ==============================================================





//############################################################################//
//#define ORBITER_MODULE
//#define _CRT_SECURE_NO_WARNINGS
//#define _CRT_NONSTDC_NO_DEPRECATE
#include <math.h>
#include <stdio.h>
//#include "orbitersdk.h"
#include <vector>


#include "GeneralVehicle.h"

//Creation
GeneralVehicle::GeneralVehicle(OBJHANDLE hObj,int fmodel):VESSEL3(hObj,fmodel){
	mydarkblue = oapiCreateBrush(0x800000);
	penblue = oapiCreatePen(1, 1, 0xFF0000);
	mydarkred = oapiCreateBrush(0x660000AA);
}
GeneralVehicle::~GeneralVehicle(){
	delete MGR_Ant_DX;
	delete MGR_Ant_SX;
	delete MGR_Post_DX;
	delete MGR_Post_SX;
	delete MGR_Middle;

	delete MGR_Sterzo_Volante;
	delete MGR_Sterzo_Ant_DX;
	delete MGR_Sterzo_Ant_SX;
	delete MGR_Sterzo_Post_DX;
	delete MGR_Sterzo_Post_SX;


	delete[] RR_Grps;
	delete[] RL_Grps;
	delete[] FR_Grps;
	delete[] FL_Grps;
	delete[] SW_Grps;
	
	delete[] Mid_n_grps;
	delete[] Middle_Axle_Pos;
	delete[] Mid_Grps;
	oapiReleaseBrush(mydarkblue);
	oapiReleaseBrush(mydarkred);
	oapiReleasePen(penblue);
}

void GeneralVehicle::clbkSetClassCaps(FILEHANDLE cfg) {

	grav_acc = 9.80655;

	double EmptyMass = 1000;
	oapiReadItem_float(cfg, "Empty_Mass", EmptyMass);
	SetEmptyMass(EmptyMass);

	char meshname[256];
	oapiReadItem_string(cfg, "Mesh", meshname);
	oapiWriteLogV("%s: Meshname:%s", GetName(), meshname);

	MESHHANDLE mh = oapiLoadMeshGlobal(meshname);
	VECTOR3 origin = _V(0, 0, 0);
	UINT mh_idx = AddMesh(mh, &origin);
	SetMeshVisibilityMode(mh_idx, MESHVIS_ALWAYS);

	if (!oapiReadItem_bool(cfg, "Is_Motorcycle", isMotorcycle)) {
		isMotorcycle = FALSE;
	}

	VECTOR3 Cockpit_pos = _V(0, 0, 0);
	oapiReadItem_vec(cfg, "Cockpit_Pos", Cockpit_pos);
	SetCameraOffset(Cockpit_pos);
	oapiWriteLogV("%s: Cockpit Position: %.3f %.3f %.3f", GetName(), Cockpit_pos.x, Cockpit_pos.y, Cockpit_pos.z);


	if (!oapiReadItem_float(cfg, "Acceleration", Acceleration)) { Acceleration = 1; }
	//Acceleration *= 9.80655;
	if (!oapiReadItem_float(cfg, "Brake", Brake)) { Brake = 1; }
	//Brake *= 9.80655;


	if (!oapiReadItem_float(cfg, "Max_Speed", Max_Speed)) { Max_Speed = 100000; }
	if (!oapiReadItem_float(cfg, "Reverse_Max_Speed", Reverse_Max_Speed)) { Reverse_Max_Speed = 0.5*Max_Speed; }
	oapiWriteLogV("%s: Acceleration:%.3f Gs Brake:%.3f Gs Maximum Speed:%.3f km/h Max Reverse Speed:%.3f km/h", GetName(), Acceleration , Brake , Max_Speed, Reverse_Max_Speed);



	if (!oapiReadItem_bool(cfg, "Always_Upright", Always_Upright)) { Always_Upright = FALSE; }
	if (Always_Upright) { oapiWriteLogV("%s: Always Upright TRUE", GetName()); }
	else { oapiWriteLogV("%s: Always Upright FALSE", GetName()); }


	
	if(!oapiReadItem_float(cfg, "Steering_Speed", Steering_Speed)) {
		Steering_Speed = 2;
	}

	
	if (!oapiReadItem_float(cfg, "Max_Steering_Angle", Max_Steering_Angle)) {
		Max_Steering_Angle = 45;
	}
	Max_Steering_Angle *= RAD;
	oapiWriteLogV("%s: Steering Speed Factor:%.3f Maximum Steering Angle:%.3f", GetName(), Steering_Speed, Max_Steering_Angle*DEG);

	if (!oapiReadItem_float(cfg, "Full_Pedal_Time", Full_Pedal_Time)) { Full_Pedal_Time = 0.01; }
	oapiWriteLogV("%s: Full Pedal Time:%.3f", GetName(), Full_Pedal_Time);
	Current_Pedal = 0;
	Current_Brake_Pedal = 0;

	RR_n_grps = 0;
	RL_n_grps = 0;
	FR_n_grps = 0;
	FL_n_grps = 0;
	SW_n_grps = 0;
	MR_n_grps = 0;
//	ML_n_grps = 0;

	Without_Wheels = FALSE;


	char Rear_Right_Grps_ch[512] = { "\0" };
	oapiReadItem_string(cfg, "Rear_Right_Groups", Rear_Right_Grps_ch);
	RR_Grps = GetGroupsFromLine(Rear_Right_Grps_ch, RR_n_grps);
	
	oapiWriteLogV("%s: Rear Right Groups: %i", GetName(),RR_n_grps);
	for (UINT i = 0; i < RR_n_grps; i++) {
		oapiWriteLogV("n.%i = %i", i, RR_Grps[i]);
	}

	char Rear_Left_Grps_ch[512] = { "\0" };
	oapiReadItem_string(cfg, "Rear_Left_Groups", Rear_Left_Grps_ch);
	RL_Grps = GetGroupsFromLine(Rear_Left_Grps_ch, RL_n_grps);

	oapiWriteLogV("%s: Rear Left Groups: %i", GetName(), RL_n_grps);
	for (UINT i = 0; i < RL_n_grps; i++) {
		oapiWriteLogV("n.%i = %i", i, RL_Grps[i]);
	}

	char Front_Left_Grps_ch[512] = { "\0" };
	oapiReadItem_string(cfg, "Front_Left_Groups", Front_Left_Grps_ch);
	FL_Grps = GetGroupsFromLine(Front_Left_Grps_ch, FL_n_grps);

	oapiWriteLogV("%s: Front Left Groups: %i", GetName(),FL_n_grps);
	for (UINT i = 0; i < FL_n_grps; i++) {
		oapiWriteLogV("n.%i = %i", i, FL_Grps[i]);
	}


	char Front_Right_Grps_ch[512] = { "\0" };
	oapiReadItem_string(cfg, "Front_Right_Groups", Front_Right_Grps_ch);
	FR_Grps = GetGroupsFromLine(Front_Right_Grps_ch, FR_n_grps);

	oapiWriteLogV("%s: Front Right Groups: %i", GetName(),FR_n_grps);
	for (UINT i = 0; i < FR_n_grps; i++) {
		oapiWriteLogV("n.%i = %i", i, FR_Grps[i]);
	}


	if (!oapiReadItem_vec(cfg, "Rear_Axle_Pos", Rear_Axle_Pos)) {
		Rear_Axle_Pos = GetMeshGroupsBarycenter(mh, RR_Grps, RR_n_grps);
		Rear_Axle_Pos.x = 0;
	}
	oapiWriteLogV("%s: Rear Axle Position-> x:%.6f y:%.6f z:%.6f", GetName(), Rear_Axle_Pos.x, Rear_Axle_Pos.y, Rear_Axle_Pos.z);

	if (!oapiReadItem_vec(cfg, "Front_Axle_Pos", Front_Axle_Pos)) {
		Front_Axle_Pos = GetMeshGroupsBarycenter(mh, FR_Grps, FR_n_grps);
	}
	oapiWriteLogV("%s: Front Right Axle Position-> x:%.6f y:%.6f z:%.6f", GetName(), Front_Axle_Pos.x, Front_Axle_Pos.y, Front_Axle_Pos.z);

	if (!oapiReadItem_vec(cfg, "Steering_Axis", Steering_Axis)) {
		Steering_Axis = GetMeshGroupsBarycenter(mh, FR_Grps, FR_n_grps);
	}
	oapiWriteLogV("%s: Steering Axis Position-> x:%.6f y:%.6f z:%.6f", GetName(), Steering_Axis.x, Steering_Axis.y, Steering_Axis.z);

	if (!oapiReadItem_float(cfg, "Camber", camber)) {
		camber = 0;
	}
	camber *= RAD;
	oapiWriteLogV("%s: Front Wheels Camber = %.3f", GetName(), camber*DEG);

	if (!oapiReadItem_float(cfg, "Front_Wheels_Diameter", Front_Wheels_Diameter)) {
		Front_Wheels_Diameter = GetWheelsDiameter(mh, FR_Grps, FR_n_grps);
	}
	oapiWriteLogV("%s: Front Wheels Diameter: %.4f", GetName(), Front_Wheels_Diameter);

	if (!oapiReadItem_float(cfg, "Rear_Wheels_Diameter", Rear_Wheels_Diameter)) {
		Rear_Wheels_Diameter = GetWheelsDiameter(mh, RR_Grps, RR_n_grps);
	}
	oapiWriteLogV("%s: Rear Wheels Diameter: %.4f", GetName(), Rear_Wheels_Diameter);

	Front_Wheels_Length = PI*Front_Wheels_Diameter;
	Rear_Wheels_Length = PI*Rear_Wheels_Diameter;

	if (!oapiReadItem_bool(cfg, "Four_Wheels_Steering", Four_Wheels_Steering)) {
		Four_Wheels_Steering = FALSE;
	}
	if (Four_Wheels_Steering) {
		if (!oapiReadItem_vec(cfg, "Rear_Steering_Axis", Rear_Steering_Axis)) {
			Rear_Steering_Axis = GetMeshGroupsBarycenter(mh, RR_Grps, RR_n_grps);
		}
		oapiWriteLogV("%s: Four Wheels Steering TRUE, Rear Steering Axis: %.3f %.3f %.3f", GetName(), Rear_Steering_Axis.x, Rear_Steering_Axis.y, Rear_Steering_Axis.z);
	}
		
		Passo = Front_Axle_Pos.z - Rear_Axle_Pos.z;
		
	if(Four_Wheels_Steering){
		Passo *= 0.5;
	}

	if (!oapiReadItem_int(cfg, "Middle_Axles_N", Middle_Axles_N)) {
		Middle_Axles_N = 0;
		Without_Middle = TRUE;
	}
	else {
		if (Middle_Axles_N > 0) {
			Without_Middle = FALSE;
			
			Mid_Grps = new DWORD*[Middle_Axles_N];
			Mid_n_grps = new UINT[Middle_Axles_N];
			Middle_Axle_Pos = new VECTOR3[Middle_Axles_N];
			
			oapiWriteLogV("%s: Middle Axles Present, n: %i",GetName(),Middle_Axles_N);
			for (UINT i = 0; i < Middle_Axles_N; i++) {
				Mid_n_grps[i] = 0;
				char Middle_Grps_ch[512] = { "0" };
				char buff_n[32] = { "0" };
				sprintf(buff_n, "Middle_Groups_%i", i+1);
				oapiReadItem_string(cfg, buff_n, Middle_Grps_ch);
			
				Mid_Grps[i] = GetGroupsFromLine(Middle_Grps_ch, Mid_n_grps[i]);
				sprintf(buff_n, "Middle_Axle_Pos_%i", i+1);
				
				if (!oapiReadItem_vec(cfg, buff_n, Middle_Axle_Pos[i])) {
					Middle_Axle_Pos[i] = GetMeshGroupsBarycenter(mh, Mid_Grps[i], Mid_n_grps[i]);
				}
				for (UINT j = 0; j < Mid_n_grps[i]; j++) {
					oapiWriteLogV("Axle:%i n.%i = %i", i+1, j, Mid_Grps[i][j]);
				}
			}
			
			if (!oapiReadItem_float(cfg, "Middle_Wheels_Diameter", Middle_Wheels_Diameter)) {
				Middle_Wheels_Diameter = GetWheelsDiameter(mh, Mid_Grps[0], Mid_n_grps[0]);
			}
			oapiWriteLogV("%s: Middle Diameter: %.3f", GetName(), Middle_Wheels_Diameter);
			Middle_Wheels_Length = PI*Middle_Wheels_Diameter;
		}
		else {
			Without_Middle = TRUE;
		}
	}

		if (FR_n_grps > 0) { w_ant_dx = TRUE; }
		else { w_ant_dx = FALSE; }
		if (FL_n_grps > 0) { w_ant_sx = TRUE; }
		else { w_ant_sx = FALSE; }
		if (RR_n_grps > 0) { w_post_dx = TRUE; }
		else { w_post_dx = FALSE; }
		if (RL_n_grps > 0) { w_post_sx = TRUE; }
		else { w_post_sx = FALSE; }

		if ((!w_ant_dx) && (!w_ant_sx) && (!w_post_dx) && (!w_post_sx)) {

			Without_Wheels = TRUE;
			Passo = 5;
			camber = 0;
			Rear_Axle_Pos = _V(0, 0, 0);
			Front_Axle_Pos = _V(0, 0, 0);
			Steering_Axis = _V(0, 1, 0);
			Front_Wheels_Diameter = 0;
			Rear_Wheels_Diameter = 0;
			Front_Wheels_Length = 0;
			Rear_Wheels_Length = 0;
			Middle_Wheels_Diameter = 0;
		}

	Without_Steering_Wheel = FALSE;

	char SW_Grps_ch[512] = { "\0" };
	if (oapiReadItem_string(cfg, "Steering_Wheel_Groups", SW_Grps_ch)) {
		SW_Grps = GetGroupsFromLine(SW_Grps_ch, SW_n_grps);

		oapiWriteLogV("%s: Steering Wheel Groups:", GetName());
		for (UINT i = 0; i < SW_n_grps; i++) {
			oapiWriteLogV("n.%i = %i", i, SW_Grps[i]);
		}

		if (!oapiReadItem_vec(cfg, "Steering_Wheel_Pos", Steering_Wheel_Pos)) {
			Steering_Wheel_Pos = GetMeshGroupsBarycenter(mh, SW_Grps, SW_n_grps);
		}
		oapiWriteLogV("%s: Steering Wheel Position-> x:%.6f y:%.6f z:%.6f", GetName(), Steering_Wheel_Pos.x, Steering_Wheel_Pos.y, Steering_Wheel_Pos.z);

		if (!oapiReadItem_vec(cfg, "Steering_Wheel_Axis", Steering_Wheel_Axis)) {
			Steering_Wheel_Axis = _V(0, 0, -1);
		}
		oapiWriteLogV("%s: Steering Wheel Axis-> x:%.3f y:%.3f z:%.3f", GetName(), Steering_Wheel_Axis.x, Steering_Wheel_Axis.y, Steering_Wheel_Axis.z);
	}
	else {
		Without_Steering_Wheel = TRUE;
		Steering_Wheel_Pos = _V(0, 0, 0);
		Steering_Wheel_Axis = _V(0, 0, -1);

	}





	if (!oapiReadItem_float(cfg, "Height_From_Ground", Height_From_Ground)) {
		Height_From_Ground = -1*GetMeshLowerPoint(mh);
	}
	oapiWriteLogV("%s: Height From Ground = %.3f", GetName(),Height_From_Ground);

	
	if (!oapiReadItem_string(cfg, "Listen_From", listenfrom)) {
		wListener = FALSE;
		for (UINT i = 0; i < 256; i++) {
			listenfrom[i] = 0;
		}
	}
	else {
		wListener = TRUE;
		oapiWriteLogV("%s: Listening From: %s", GetName(), listenfrom);
	}

	  SetClipRadius(0.01);
	  SetSize(1);
	  double ro = Passo;
	  TOUCHDOWNVTX td[4];

	  double x_target = -0.5;
	  double stiffness = (-1)*(EmptyMass*9.80655) / (3 * x_target);
	  double damping = 0.9*(2 * sqrt(EmptyMass*stiffness));
	  for (int i = 0; i<4; i++)
	  {

		  td[i].damping = damping;
		  td[i].mu = 3;
		  td[i].mu_lng = 3;
		  td[i].stiffness = stiffness;
	  }
	  td[0].pos.x = cos(30 * RAD)*ro;
	  td[0].pos.y = -Height_From_Ground;
	  td[0].pos.z = -sin(30*RAD)*ro;
	  td[1].pos.x = 0;
	  td[1].pos.y = -Height_From_Ground;
	  td[1].pos.z = 1*ro;
	  td[2].pos.x = -cos(30 * RAD)*ro;
	  td[2].pos.y = -Height_From_Ground;
	  td[2].pos.z = -sin(30 * RAD)*ro;
	  td[3].pos.x = 0;
	  td[3].pos.y = 15 * ro;
	  td[3].pos.z = 0;


	  SetTouchdownPoints(td, 4);





CurrentSpeed=0;
Angular_Acceleration=0;
CurrentAngularSpeed=0;
CurrentSterzo = 0;
FWD = FALSE;
BWD = FALSE;
LFT = FALSE;
RGT = FALSE;

if (!oapiReadItem_vec(cfg, "Towing_Attachment_Pos", Towing_Attachment_Pos)) {
	Towing_Attachment_Pos = _V(0, 0, 0);
}
oapiWriteLogV("%s: Towing Attachment Position: %.3f %.3f %.3f", GetName(), Towing_Attachment_Pos.x, Towing_Attachment_Pos.y, Towing_Attachment_Pos.z);

Towing_att = CreateAttachment(FALSE, Towing_Attachment_Pos, _V(0, 0, -1), _V(0, 1, 0), "TW", FALSE);

if (!oapiReadItem_float(cfg, "Tow_Max_Angle", Tow_Max_Angle))
{
	Tow_Max_Angle = 160;
}
oapiWriteLogV("%s: Tow Max Angle:%.1f", GetName(),Tow_Max_Angle);

Tow_Max_Angle *= RAD;

if (!Without_Wheels) {
	DefineAnimations();
}

VECTOR3 front_lights_pos;
if (!oapiReadItem_vec(cfg, "Front_Lights_pos", front_lights_pos)) {
	front_lights_pos = _V(0, 1, 3);
}
VECTOR3 rear_lights_pos;
if (!oapiReadItem_vec(cfg, "Rear_Lights_pos", rear_lights_pos)) {
	rear_lights_pos = _V(0, 1, -3);
}
const double att = 0.0001;
COLOUR4 col;
col.r = 1;
col.b = 1;
col.g = 1;
col.a = 0.2;
FrontLights[0] = AddSpotLight(front_lights_pos, _V(0, sin(10*RAD), cos(10*RAD)), 200, att, att, att, 45 * RAD, 60 * RAD, col, col, col);
front_lights_pos.x *= -1;
FrontLights[1] = AddSpotLight(front_lights_pos, _V(0, sin(10*RAD), cos(10*RAD)), 200, att, att, att, 45 * RAD, 60 * RAD, col, col, col);

col.b = 0;
col.g = 0;
RearLights[0]= AddSpotLight(rear_lights_pos, _V(0, 0, -1), 100, att, att, att, 45 * RAD, 60 * RAD, col, col, col);
rear_lights_pos.x *= -1;
RearLights[1] = AddSpotLight(rear_lights_pos, _V(0, 0, -1), 100, att, att, att, 45 * RAD, 60 * RAD, col, col, col);
for (UINT q = 0; q < 2; q++) {
	FrontLights[q]->Activate(FALSE);
	RearLights[q]->Activate(FALSE);
}

	return;
}


DWORD* GeneralVehicle::GetGroupsFromLine(char *line,  UINT &n_groups) {
	string str(line);
	
	std::vector<std::string> results;
	std::size_t pos = 0, found;
	while ((found = str.find_first_of(' ', pos)) != std::string::npos) {
		results.push_back(str.substr(pos, found - pos));
		pos = found + 1;
	}
	results.push_back(str.substr(pos));
	DWORD *grps;
	grps = new DWORD[results.size()];

	for (UINT i = 0; i < results.size(); i++)
	{
		grps[i] = atoi(results[i].c_str());
		
	}
	if (results.size() == 1) {
		if (results[0].empty()) {
			results.clear();
		}
	}
	n_groups = results.size();
	return grps;
}

VECTOR3 GeneralVehicle::GetMeshGroupsBarycenter(MESHHANDLE mh, DWORD *group_idx, UINT n_groups)
{

	double XG, YG, ZG;
	XG = 0;
	YG = 0;
	ZG = 0;
	UINT k = 0;


	for (UINT i = 0; i < n_groups; i++) {
		MESHGROUPEX *mgp = oapiMeshGroupEx(mh, group_idx[i]);
		for (DWORD j = 0; j < mgp->nVtx; j++)
		{
			XG += mgp->Vtx[j].x;
			YG += mgp->Vtx[j].y;
			ZG += mgp->Vtx[j].z;
			k += 1;	
		}

	}
	
	XG /= k;
	YG /= k;
	ZG /= k;

	
	return _V(XG, YG, ZG);
}
double GeneralVehicle::GetMeshLowerPoint(MESHHANDLE mh) {
	
	DWORD groupscount = oapiMeshGroupCount(mh);
	double Ymin;
	if (groupscount > 0) { 
		MESHGROUPEX *mg = oapiMeshGroupEx(mh, 0); 
		Ymin = mg->Vtx[0].y;
	}
	for (DWORD i = 0; i < groupscount; i++) {
		MESHGROUPEX *mgp = oapiMeshGroupEx(mh, i);
		
		for (DWORD j = 0; j < mgp->nVtx; j++) {
			if (mgp->Vtx[j].y < Ymin) { Ymin = mgp->Vtx[j].y; }
		}
	}
	
	return Ymin;

}

VECTOR3 GeneralVehicle::GetMeshBarycenter(MESHHANDLE mh) {
	DWORD *allgroups;
	DWORD groupscount = oapiMeshGroupCount(mh);
	allgroups = new DWORD[groupscount];
	for (DWORD i = 0; i < groupscount; i++) {
		allgroups[i] = i;
	}
	VECTOR3 cog = GetMeshGroupsBarycenter(mh, allgroups, groupscount);
	delete allgroups;
	return cog;
}

double GeneralVehicle::GetWheelsDiameter(MESHHANDLE mh, DWORD *group_idx, UINT n_groups) {
	MESHGROUPEX *mg = oapiMeshGroupEx(mh, group_idx[0]);
	double max_y = mg->Vtx[0].y;
	double min_y = max_y;

	for (UINT i = 0; i < n_groups; i++) {
		MESHGROUPEX *mgp = oapiMeshGroupEx(mh, group_idx[i]);
		for (DWORD i = 0; i < mgp->nVtx; i++)
		{
			if (mgp->Vtx[i].y > max_y) {
				max_y = mgp->Vtx[i].y;
			}
			if (mgp->Vtx[i].y < min_y) {
				min_y = mgp->Vtx[i].y;
			}
		}
	}
		return (max_y - min_y);
}
MATRIX3 GeneralVehicle::RotationMatrix(VECTOR3 angles, bool xyz = FALSE)
{
	MATRIX3 m;
	MATRIX3 RM_X, RM_Y, RM_Z;
	RM_X = _M(1, 0, 0, 0, cos(angles.x), -sin(angles.x), 0, sin(angles.x), cos(angles.x));
	RM_Y = _M(cos(angles.y), 0, sin(angles.y), 0, 1, 0, -sin(angles.y), 0, cos(angles.y));
	RM_Z = _M(cos(angles.z), -sin(angles.z), 0, sin(angles.z), cos(angles.z), 0, 0, 0, 1);
	if (!xyz) {
		m = mul(RM_Z, mul(RM_Y, RM_X));
	}
	else {
		m = mul(RM_X, mul(RM_Y, RM_Z));
	}
	return m;
}

void GeneralVehicle::DefineAnimations() {

	State_Post = 0;
	State_Ant = 0;
	State_Mid = 0;



	Anim_Sterzo = CreateAnimation(0);
	Anim_Post = CreateAnimation(0);
	Anim_Ant = CreateAnimation(0);
	if (!Without_Steering_Wheel) { 
		MGR_Sterzo_Volante =new MGROUP_ROTATE (0, (UINT*)SW_Grps, SW_n_grps, Steering_Wheel_Pos, Steering_Wheel_Axis, (float)PI2);
		AddAnimationComponent(Anim_Sterzo, -0.5, 0.5, MGR_Sterzo_Volante);
	}
	if (w_ant_dx) {
		MGR_Sterzo_Ant_DX = new MGROUP_ROTATE(0, (UINT*)FR_Grps, 0, Steering_Axis, _V(0, 1, 0), (float)2 * Max_Steering_Angle * !isMotorcycle); 
		ANIMATIONCOMPONENT_HANDLE sterzo_ant_dx = AddAnimationComponent(Anim_Sterzo, -0.5, 0.5, MGR_Sterzo_Ant_DX);
		MGR_Ant_DX = new MGROUP_ROTATE(0, (UINT*)FR_Grps, FR_n_grps, Front_Axle_Pos, _V(cos(camber), sin(camber), 0), (float)PI2);
		ANIMATIONCOMPONENT_HANDLE rotazione_ant_dx = AddAnimationComponent(Anim_Ant, 0, 1, MGR_Ant_DX, sterzo_ant_dx);
	}
	Front_Axle_Pos.x *= -1;
	Steering_Axis.x *= -1;
	if (w_ant_sx) {
		MGR_Sterzo_Ant_SX = new MGROUP_ROTATE(0, (UINT*)FL_Grps, 0, Steering_Axis, _V(0, 1, 0), (float)2 * Max_Steering_Angle * !isMotorcycle);
		ANIMATIONCOMPONENT_HANDLE sterzo_ant_sx = AddAnimationComponent(Anim_Sterzo, -0.5, 0.5, MGR_Sterzo_Ant_SX);
		MGR_Ant_SX = new MGROUP_ROTATE(0, (UINT*)FL_Grps, FL_n_grps, Front_Axle_Pos, _V(-cos(camber), sin(camber), 0), (float)-PI2);
		AddAnimationComponent(Anim_Ant, 0, 1, MGR_Ant_SX, sterzo_ant_sx);
	}
	if (w_post_dx) {
		MGR_Sterzo_Post_DX = new MGROUP_ROTATE(0, (UINT*)RR_Grps, 0, Rear_Steering_Axis, _V(0, -1, 0), (float)2 * Max_Steering_Angle*Four_Wheels_Steering);
		ANIMATIONCOMPONENT_HANDLE sterzo_post_dx = AddAnimationComponent(Anim_Sterzo, -0.5, 0.5, MGR_Sterzo_Post_DX);
		MGR_Post_DX = new MGROUP_ROTATE(0, (UINT*)RR_Grps, RR_n_grps, Rear_Axle_Pos, _V(1, 0, 0), (float)PI2);
		AddAnimationComponent(Anim_Post, 0, 1, MGR_Post_DX, sterzo_post_dx);
	}

	Rear_Steering_Axis.x *= -1;
	if (w_post_sx){
		MGR_Sterzo_Post_SX = new MGROUP_ROTATE(0, (UINT*)RL_Grps, 0, Rear_Steering_Axis, _V(0, -1, 0), (float)2 * Max_Steering_Angle*Four_Wheels_Steering);
		ANIMATIONCOMPONENT_HANDLE sterzo_post_sx = AddAnimationComponent(Anim_Sterzo, -0.5, 0.5, MGR_Sterzo_Post_SX);
		MGR_Post_SX = new MGROUP_ROTATE(0, (UINT*)RL_Grps, RL_n_grps, Rear_Axle_Pos, _V(1, 0, 0), (float)PI2);
		AddAnimationComponent(Anim_Post, 0, 1, MGR_Post_SX, sterzo_post_sx);
	}
	
/////////MIDDLE AXLE ANIMATIONS

	if (!Without_Middle) {
		Anim_Mid = CreateAnimation(0);
		MGR_Middle = new MGROUP_ROTATE*[Middle_Axles_N];
		for (UINT i = 0; i < Middle_Axles_N; i++) {
			MGR_Middle[i] = new MGROUP_ROTATE(0, (UINT*)Mid_Grps[i], Mid_n_grps[i], Middle_Axle_Pos[i], _V(1, 0, 0), (float)PI2);
			AddAnimationComponent(Anim_Mid, 0, 1, MGR_Middle[i]);
		}
	}


	Front_Axle_Pos.x *= -1;
	
	return;
}

double GeneralVehicle::SteerReturnFunction(double x_input, double amplitude, double zero_interval=0) {
	if (x_input < 0) {
		return x_input+amplitude;
	}
	else if (x_input <= abs(zero_interval)) {
		return 0;
	}
	else {
		return x_input-amplitude;
	}
}
OBJHANDLE GeneralVehicle::ClosestAvailableVessel(ATTACHMENTHANDLE &att, double &dist) {
	DWORD count = oapiGetVesselCount();
	
	struct Infos{
		OBJHANDLE h;
		double distance;
		ATTACHMENTHANDLE h_attach;
		double Passo_target_traino;
	};
	vector<Infos> valids;
	valids.clear();
	UINT counter = 0;
	for (DWORD i = 0; i < oapiGetVesselCount(); i++) {
		OBJHANDLE h = oapiGetVesselByIndex(i);
		VESSEL* v = (VESSEL*)oapiGetVesselInterface(h);
		DWORD att_count = v->AttachmentCount(TRUE);
		for (DWORD j = 0; j < att_count; j++) {
			ATTACHMENTHANDLE att_h = v->GetAttachmentHandle(TRUE, j);
			const char *Id;
			Id=v->GetAttachmentId(att_h);
			if (strncmp(Id,"TW",2)==0) {
				double distance;
				VECTOR3 rpos;
				oapiGetRelativePos(GetHandle(), h, &rpos);
				distance = length(rpos);
	
				Infos Inf;
				Inf.distance = distance;
				Inf.h = h;
				Inf.h_attach = att_h;
				sscanf(Id, "TW_%lf", &Inf.Passo_target_traino);
				valids.push_back(Inf);
	
			}
		}
	}
	
	double test = 0;
	UINT chosen = 0;
	ATTACHMENTHANDLE ret_att_h = 0;
	OBJHANDLE ret = 0;
	if (valids.size() > 0) {
		test = valids[0].distance;
		ret_att_h = valids[0].h_attach;
		ret = valids[0].h;
		Passo_traino = valids[0].Passo_target_traino;
		dist = valids[0].distance;
		for (UINT k = 0; k < valids.size(); k++) {
		
			if (valids[k].distance < test) {
				test = valids[k].distance;
		
				chosen = k;
				ret_att_h = valids[k].h_attach;
				ret = valids[k].h;
				Passo_traino = valids[k].Passo_target_traino;
				dist = valids[k].distance;
			}
		}
		
	}
	if (oapiIsVessel(ret)) {
		
		att = ret_att_h;
		
		return ret;
	}else{
		
		return 0;
	}
	
}
int GeneralVehicle::clbkConsumeBufferedKey(DWORD key, bool down, char *kstate) {
	if ((KEYDOWN(kstate, OAPI_KEY_G)) && (KEYMOD_CONTROL(kstate)) && (!KEYMOD_SHIFT(kstate)) && (!KEYMOD_ALT(kstate))) {
		if (GetAttachmentStatus(Towing_att) == NULL) {
			ATTACHMENTHANDLE target_att_h = 0;
			double distance = 100;
			OBJHANDLE target = ClosestAvailableVessel(target_att_h,distance);
			if (oapiIsVessel(target)&&(distance<50)) {
				AttachChild(target, Towing_att, target_att_h);
			}
		}
		else {
			DetachChild(Towing_att);
		}
		return 1;
	}
	if ((KEYDOWN(kstate, OAPI_KEY_L)) && (KEYMOD_CONTROL(kstate)) && (!KEYMOD_SHIFT(kstate)) && (!KEYMOD_ALT(kstate))) {
		for (UINT j = 0; j < 2; j++) {
			FrontLights[j]->Activate(!FrontLights[j]->IsActive());
			RearLights[j]->Activate(!RearLights[j]->IsActive());
			RearLights[j]->SetIntensity(0.001);
		}
		return 1;
	}
	return 0;
}

int GeneralVehicle::clbkConsumeDirectKey(char *kstate)
{
	if (RearLights[0]->IsActive()) {
		RearLights[0]->SetIntensity(0.001);
		RearLights[1]->SetIntensity(0.001);
	}

	if (KEYDOWN(kstate, OAPI_KEY_NUMPAD8) && (!KEYMOD_CONTROL(kstate)) && (!KEYMOD_SHIFT(kstate) && (!KEYMOD_ALT(kstate)))) {
		if(CurrentSpeed<=(Max_Speed/3.6)){ 
			Current_Pedal += oapiGetSimStep() / Full_Pedal_Time;
			if (Current_Pedal > 1) { Current_Pedal = 1; }
			CurrentSpeed += Current_Pedal*Acceleration*grav_acc*oapiGetSimStep(); 
		}
	}
	else { Current_Pedal = 0; }
	if (KEYDOWN(kstate, OAPI_KEY_NUMPAD2) && (!KEYMOD_CONTROL(kstate)) && (!KEYMOD_SHIFT(kstate) && (!KEYMOD_ALT(kstate)))) {
		Current_Brake_Pedal += oapiGetSimStep() / Full_Pedal_Time;
		if (Current_Brake_Pedal > 1) { Current_Brake_Pedal = 1; }
		CurrentSpeed -= Current_Brake_Pedal*Brake*grav_acc*oapiGetSimStep();
		if (CurrentSpeed < 0) { CurrentSpeed = 0; }
		if (RearLights[0]->IsActive()) {
			RearLights[0]->SetIntensity(1);
			RearLights[1]->SetIntensity(1);
		}
	}
	else { Current_Brake_Pedal = 0; }
	if (KEYDOWN(kstate, OAPI_KEY_NUMPAD2) && (KEYMOD_CONTROL(kstate)) && (!KEYMOD_SHIFT(kstate) && (!KEYMOD_ALT(kstate)))) {
		if (CurrentSpeed <= 0) {
			if (CurrentSpeed >= -1*Reverse_Max_Speed / 3.6) { CurrentSpeed -= Brake*oapiGetSimStep(); }
		}
	}
	if (KEYDOWN(kstate, OAPI_KEY_NUMPAD4) && (!KEYMOD_SHIFT(kstate) && (!KEYMOD_ALT(kstate)))) {
		if (KEYMOD_CONTROL(kstate)) {
			CurrentSterzo -= 0.1*Steering_Speed*oapiGetSimStep();
		}
		else {
			CurrentSterzo -= Steering_Speed*oapiGetSimStep();
		}
		
		if (CurrentSterzo < -0.5) { CurrentSterzo = -0.5; }
	}else if (KEYDOWN(kstate, OAPI_KEY_NUMPAD6)  && (!KEYMOD_SHIFT(kstate) && (!KEYMOD_ALT(kstate)))) {
		if (KEYMOD_CONTROL(kstate)) {
			CurrentSterzo += 0.1*Steering_Speed*oapiGetSimStep();
		}
		else {
			CurrentSterzo += Steering_Speed*oapiGetSimStep();
		}
		
		if (CurrentSterzo > 0.5) { CurrentSterzo = 0.5; }
	}
	
	else { CurrentSterzo = SteerReturnFunction(CurrentSterzo, Steering_Speed*oapiGetSimStep(),0.05 ); }
	if (CurrentSterzo < -0.5) { CurrentSterzo = -0.499; }
	else if (CurrentSterzo > 0.5) { CurrentSterzo = 0.499; }

	if (KEYDOWN(kstate, OAPI_KEY_NUMPAD5) && (!KEYMOD_CONTROL(kstate)) && (!KEYMOD_SHIFT(kstate) && (!KEYMOD_ALT(kstate)))) {
		CurrentSterzo = 0;
	}

	if (CurrentSpeed > 0) {
		FWD = TRUE;
	}
	else { FWD = FALSE; }

	if (CurrentSpeed < 0) { BWD = TRUE; }
	else { BWD = FALSE; }

	if (CurrentSterzo < 0) { LFT = TRUE; RGT = FALSE; }
	else if (CurrentSterzo > 0) { LFT = FALSE; RGT = TRUE; }
	else if (CurrentSterzo == 0) { LFT = FALSE; RGT = FALSE; }

	
	return 0;
}

bool GeneralVehicle::clbkDrawHUD(int mode, const HUDPAINTSPEC *hps, oapi::Sketchpad *skp) {
	VESSEL3::clbkDrawHUD(mode, hps, skp);
	
	
	
	
	int cx = hps->CX, cy = hps->CY;

	DWORD w;
	DWORD h;
	DWORD bpp;
	oapiGetViewportSize(&w, &h, &bpp);
	int len = 0;
	char buff[64];
	skp->SetPen(penblue);
	skp->SetBrush(NULL);
	skp->Rectangle(0.03*w, 0.25*h, 0.04*w, 0.35*h);
	skp->Rectangle(0.042*w, 0.25*h, 0.052*w, 0.35*h);
	skp->SetBrush(mydarkblue);
	int Pedal_height = (int)(Current_Pedal*0.096*h);
	skp->Rectangle(0.0305*w, 0.252*h+0.096*h-Pedal_height, 0.0395*w, 0.252*h+0.096*h);
	skp->SetTextColor(0xFF0000);
	Pedal_height = (int)(Current_Brake_Pedal*0.096*h);
	skp->SetBrush(mydarkred);
	skp->Rectangle(0.0425*w, 0.252*h + 0.096*h - Pedal_height, 0.0515*w, 0.252*h + 0.096*h);
	len = sprintf_s(buff, "Speed: %.1f km/h", CurrentSpeed*3.6);
	skp->Text(0.03*w, 0.252*h + 0.096*h + 0.1*h, buff, len);
	
	return true;
}

void GeneralVehicle::clbkPostCreation()
{
	if (GetAttachmentStatus(Towing_att) != NULL) {

		DetachChild(Towing_att);
		ATTACHMENTHANDLE target_att_h = 0;
		double distance=100;
		OBJHANDLE target = ClosestAvailableVessel(target_att_h,distance);
		if (oapiIsVessel(target)&&(distance<50)) {
			AttachChild(target, Towing_att, target_att_h);
		}

	}
}
void GeneralVehicle::clbkLoadStateEx(FILEHANDLE scn,void *vs)
{
	char *line;
	while(oapiReadScenario_nextline(scn,line)){
		ParseScenarioLineEx(line,vs);}



}
//############################################################################//
void GeneralVehicle::clbkSaveState(FILEHANDLE scn)
{
	SaveDefaultState(scn);
	
}
void GeneralVehicle::CheckListener() {
	
		OBJHANDLE sender = oapiGetVesselByName(listenfrom);
		if (oapiIsVessel(sender)) {

			char ks[256];
			for (UINT i = 0; i < 256; i++) {
				ks[i] = 0x00;
			}
			if (oapiGetFocusObject() == sender) {
				if (GetAsyncKeyState(VK_NUMPAD8) != 0)
				{
					ks[OAPI_KEY_NUMPAD8] = 0x80;
				}
				if (GetAsyncKeyState(VK_NUMPAD2) != 0) {
					ks[OAPI_KEY_NUMPAD2] = 0x80;
				}
				if (GetAsyncKeyState(VK_NUMPAD4) != 0) {
					ks[OAPI_KEY_NUMPAD4] = 0x80;
				}
				if (GetAsyncKeyState(VK_NUMPAD6) != 0) {
					ks[OAPI_KEY_NUMPAD6] = 0x80;
				}
				if (GetAsyncKeyState(VK_NUMPAD5) != 0) {
					ks[OAPI_KEY_NUMPAD5] = 0x80;
				}
				if (GetAsyncKeyState(VK_CONTROL) != 0) {
					ks[OAPI_KEY_LCONTROL] = 0x80;
				}
				clbkConsumeDirectKey(ks);
				if (GetAsyncKeyState('G') != 0 & 0x1) {
					ks[OAPI_KEY_G] = 0x80;
					SendBufferedKey(OAPI_KEY_G, TRUE, ks);
				}else if(GetAsyncKeyState('L') & 0x1){
					ks[OAPI_KEY_L] = 0x80;
					SendBufferedKey(OAPI_KEY_L, TRUE, ks);
				}
				

			}

		}
	return;
}
void GeneralVehicle::clbkPreStep(double simt, double simdt, double mjd)
{
	
	if (wListener) { CheckListener(); }

	rt = oapiGetSize(GetSurfaceRef());
	earth_circ = rt * 2 * PI;
	each_deg = earth_circ / 360;
	grav_acc = GGRAV*oapiGetMass(GetSurfaceRef()) /( rt*rt);
	memset(&vs2, 0, sizeof(vs2));
	vs2.version = 2;
	GetStatusEx(&vs2);

	

	
	double theta = 0;
	if (Passo_traino == 0) { Passo_traino = 1; }

	if (RGT || LFT) {
		if(FWD||BWD){
			double angolo_sterzata = CurrentSterzo*2*Max_Steering_Angle;
			
			if (!isMotorcycle) {
				theta = (CurrentSpeed*oapiGetSimStep()*tan(angolo_sterzata)) / (Passo);
			}
			else {
				double radius = (CurrentSpeed*CurrentSpeed) / (grav_acc*tan(CurrentSterzo*2*Max_Steering_Angle));
				theta = CurrentSpeed*oapiGetSimStep() / radius;
			}
			vs2.surf_hdg += theta;
			if (vs2.surf_hdg > PI2) { vs2.surf_hdg -= PI2; }
			if (vs2.surf_hdg <0) { vs2.surf_hdg += PI2; }
		}
		
	}

	if (FWD||BWD) {
		double d_lat = (CurrentSpeed*oapiGetSimStep()*cos(vs2.surf_hdg)) / each_deg;
		double d_lng = (CurrentSpeed*oapiGetSimStep()*sin(vs2.surf_hdg)) / each_deg;
		vs2.surf_lat += d_lat*RAD;
		vs2.surf_lng += d_lng*RAD;
	}

	double lng, lat, hdg;
	lng = vs2.surf_lng;
	lat = vs2.surf_lat;
	hdg = vs2.surf_hdg;
	
	VECTOR3 ant_dx_pos = Front_Axle_Pos;
	double ant_dx_dlat = ((ant_dx_pos.z*cos(hdg) - ant_dx_pos.x*sin(hdg))/each_deg)*RAD;
	double ant_dx_dlng = ((ant_dx_pos.z*sin(hdg) + ant_dx_pos.x*cos(hdg)) / each_deg)*RAD;
	double elev_ant_dx = oapiSurfaceElevation(GetSurfaceRef(), lng+ant_dx_dlng, lat+ant_dx_dlat);
	
	VECTOR3 ant_sx_pos = _V(Front_Axle_Pos.x*-1, Front_Axle_Pos.y, Front_Axle_Pos.z);
	double ant_sx_dlat = ((ant_sx_pos.z*cos(hdg) - ant_sx_pos.x*sin(hdg)) / each_deg)*RAD;
	double ant_sx_dlng = ((ant_sx_pos.z*sin(hdg) + ant_sx_pos.x*cos(hdg)) / each_deg)*RAD;
	double elev_ant_sx = oapiSurfaceElevation(GetSurfaceRef(), lng + ant_sx_dlng, lat + ant_sx_dlat);
	

	VECTOR3 post_pos = Rear_Axle_Pos;
	double post_dlat = ((+post_pos.z*cos(hdg)) / each_deg)*RAD;
	double post_dlng = ((+post_pos.z*sin(hdg)) / each_deg)*RAD;
	double elev_post = oapiSurfaceElevation(GetSurfaceRef(), lng + post_dlng, lat + post_dlat);


	double roll_angle; 
	
	double pitch_angle; 
	if (Always_Upright) {
		roll_angle = 0;
		pitch_angle = 0;
	}
	else {
		if (!isMotorcycle) {
			roll_angle = atan2(elev_ant_dx - elev_ant_sx, ant_dx_pos.x - ant_sx_pos.x);
		}
		else {
			roll_angle = -CurrentSterzo * 2*Max_Steering_Angle;
		}
		pitch_angle = atan2(-elev_post + ((elev_ant_dx + elev_ant_sx)*0.5), ant_dx_pos.z - post_pos.z);
	}
	if (FWD || BWD || RGT || LFT)
	{
		MATRIX3 rot1 = RotationMatrix(_V(0 * RAD, (90 * RAD - lng), 0 * RAD), TRUE);
		MATRIX3 rot2 = RotationMatrix(_V(-lat + 0 * RAD, 0, 0 * RAD), TRUE);
		MATRIX3 rot3 = RotationMatrix(_V(0, 0, 180 * RAD + hdg), TRUE);
		
		
		//MATRIX3 rot4 = RotationMatrix(_V(90 * RAD, 0, 0), TRUE);
		MATRIX3 rot4 = RotationMatrix(_V(90*RAD-pitch_angle, 0, roll_angle), TRUE);

//		MATRIX3 rot_pitch = RotationMatrix(_V(pitch_angle, 0, 0));
	//	MATRIX3 rot_roll = RotationMatrix(_V(0, 0, roll_angle));
	
		MATRIX3 RotMatrix_Def = mul(rot1, mul(rot2, mul(rot3, rot4)));




		vs2.arot.x = atan2(RotMatrix_Def.m23, RotMatrix_Def.m33);
		vs2.arot.y = -asin(RotMatrix_Def.m13);
		vs2.arot.z = atan2(RotMatrix_Def.m12, RotMatrix_Def.m11);
		
		if (!isMotorcycle) { vs2.vrot.x = Height_From_Ground; }
		else { 
			double gamma= CurrentSterzo * 2 * Max_Steering_Angle;
			vs2.vrot.x = Height_From_Ground * cos(gamma);
		}
		DefSetStateEx(&vs2);
	}

	if (!Without_Wheels) {
		State_Post += CurrentSpeed*oapiGetSimStep() / Rear_Wheels_Length;
		State_Ant += CurrentSpeed*oapiGetSimStep() / Front_Wheels_Length;
		if (!Without_Middle) {
			State_Mid += CurrentSpeed*oapiGetSimStep() / Middle_Wheels_Length;
			if (State_Mid > 1) { State_Mid -= (int)State_Mid; }
			else if (State_Mid < 0) { State_Mid += 1; }
		}
		if (State_Post > 1) { State_Post -= (int)State_Post; }
		else if (State_Post < 0) { State_Post += 1; }
		if (State_Ant > 1) { State_Ant -= 1; }
		else if (State_Ant < 0) { State_Ant += 1; }
		SetAnimation(Anim_Post, State_Post);
		SetAnimation(Anim_Ant, State_Ant);
		if (!Without_Middle) { SetAnimation(Anim_Mid, State_Mid); }
		SetAnimation(Anim_Sterzo, CurrentSterzo);
	}
	

	if (GetAttachmentStatus(Towing_att) != NULL) {
		VECTOR3 pos, dir, rot;
		GetAttachmentParams(Towing_att, pos, dir, rot);
		
		double alpha = 0;
		if (dir.x == 0) {
			alpha = 0;
		}
		else { 
			alpha=acos(-dir.z)*dir.x / abs(dir.x); 
		}
		double d_alpha = oapiGetSimStep()*CurrentSpeed*sin(alpha) / Passo_traino;
		alpha -= (d_alpha-theta);
		if (alpha > Tow_Max_Angle) { alpha = Tow_Max_Angle; }
		if (alpha < -Tow_Max_Angle) { alpha = -Tow_Max_Angle; }
		dir = _V(sin(alpha), 0, -cos(alpha));
		SetAttachmentParams(Towing_att, pos, dir, rot);
		
	}


	return;
}

void GeneralVehicle::clbkPostStep(double simt, double simdt, double mjd) {
	
	return;
}

int GeneralVehicle::clbkGeneric(int msgid, int prm, void *context)
{
	return 0;
}
//Creation
DLLCLBK void InitModule(HINSTANCE hModule){}
DLLCLBK void ExitModule(HINSTANCE hModule){}
DLLCLBK VESSEL *ovcInit(OBJHANDLE hvessel,int flightmodel){return new GeneralVehicle(hvessel,flightmodel);}
DLLCLBK void ovcExit(VESSEL *vessel){if(vessel)delete(GeneralVehicle*)vessel;}

