/*********************************************************************************************
This file is part of GeneralVehicle project
Copyright belogs to Fred18 for module implementation and its code

GeneralVehicle is distributed FREEWARE. Its code is distributed along with the dll. Nobody is authorized to exploit the module or the code or parts of them commercially directly or indirectly.
You CAN distribute the dll together with your addon but in this case you MUST:
-	Include credit to the author in your addon documentation;
-	Add to the addon documentation the official link of Orbit Hangar Mods for download and suggest to download the latest and updated version of the module.
You CAN use parts of the code of GeneralVehicle, but in this case you MUST:
-	Give credits in your copyright header and in your documentation for the part you used.
-	Let your project be open source and its code available for at least visualization by other users.
You CAN NOT use the entire code for making and distributing the very same module claiming it as your work entirely or partly.
You CAN NOT claim that GeneralVehicle is an invention of yourself or a work made up by yourself, or anyhow let intend that is not made and coded by the author.
You install and use GeneralVehicle at your own risk, author will not be responsible for any claim or damage subsequent to its use or for the use of part of it or of part of its code.
*********************************************************************************************/

//****************************************************/

// ==============================================================
//						GeneralVehicle
//                  
//					       By Fred18
//                  
//
// GeneralVehicle.h
// ==============================================================



#define _CRT_SECURE_NO_WARNINGS
#define _CRT_NONSTDC_NO_DEPRECATE
#define ORBITER_MODULE

#include "orbitersdk.h"

using namespace std;

class GeneralVehicle:public VESSEL3{
public:
 GeneralVehicle(OBJHANDLE hObj,int fmodel);
 ~GeneralVehicle();
 void clbkSetClassCaps(FILEHANDLE cfg);
 void clbkLoadStateEx(FILEHANDLE scn,void *vs);
 void clbkSaveState(FILEHANDLE scn);
 void clbkPostCreation();
 void clbkPreStep(double simt, double simdt, double mjd);
 void clbkPostStep(double simt, double simdt, double mjd);
 int clbkGeneric(int msgid, int prm, void *context);
 bool clbkDrawHUD(int mode, const HUDPAINTSPEC *hps, oapi::Sketchpad *skp);
 int clbkConsumeBufferedKey(DWORD key, bool down, char *kstate);
 OBJHANDLE ClosestAvailableVessel(ATTACHMENTHANDLE &att, double &dist);
 double Passo_traino;
 bool FWD, BWD, LFT, RGT;
 double Acceleration;
 double Brake;
 double CurrentSpeed;
 double Max_Speed;
 double Reverse_Max_Speed;
 double Full_Pedal_Time;
 double Current_Pedal;
 double Current_Brake_Pedal;
 bool Always_Upright;
 double Steering_Speed;
 double Max_Steering_Angle;
 double Angular_Acceleration;
 double CurrentAngularSpeed;
 double Height_From_Ground;
 double Front_Wheels_Diameter;
 double Rear_Wheels_Diameter;

 double Middle_Wheels_Diameter;

 double Front_Wheels_Length;
 double Rear_Wheels_Length;

 double Middle_Wheels_Length;

 DWORD *RR_Grps, *RL_Grps, *FR_Grps, *FL_Grps, *SW_Grps, *MR_Grps;// , *ML_Grps;
 DWORD **Mid_Grps;
 UINT RR_n_grps, RL_n_grps, FR_n_grps, FL_n_grps, SW_n_grps, MR_n_grps;// , ML_n_grps;
 UINT *Mid_n_grps;
 VECTOR3 Rear_Axle_Pos;
 VECTOR3 Front_Axle_Pos;
  VECTOR3 *Middle_Axle_Pos;
 VECTOR3 Steering_Axis;
 VECTOR3 Rear_Steering_Axis;
 VECTOR3 Steering_Wheel_Pos;
 VECTOR3 Steering_Wheel_Axis;

 double camber;

 DWORD* GetGroupsFromLine(char *line, UINT &n_groups);

 VECTOR3 GetMeshGroupsBarycenter(MESHHANDLE mh, DWORD *group_idx, UINT n_groups);
 VECTOR3 GetMeshBarycenter(MESHHANDLE mh);
 double GetWheelsDiameter(MESHHANDLE mh, DWORD *groudp_idx, UINT n_groups);
 double GetMeshLowerPoint(MESHHANDLE mh);
 double CurrentSterzo;

 VESSELSTATUS2 vs2;
 int clbkConsumeDirectKey(char *kstate);

 double rt, earth_circ, each_deg;

 MATRIX3 RotationMatrix(VECTOR3 angles, bool xyz);

 double Passo;

 void DefineAnimations();
 bool w_ant_sx, w_ant_dx, w_post_sx, w_post_dx,w_steering_wheel,w_middle_wheels;
 UINT Anim_Post;
 UINT Anim_Ant;
 UINT Anim_Sterzo;
 UINT Anim_Mid;
 double State_Post;
 double State_Ant;
 double State_Mid;
 double State_Sterzo;
 MGROUP_ROTATE *MGR_Post_DX;
 MGROUP_ROTATE *MGR_Post_SX;

 MGROUP_ROTATE *MGR_Ant_DX;
 MGROUP_ROTATE *MGR_Ant_SX;
 MGROUP_ROTATE *MGR_Sterzo_Volante;
 MGROUP_ROTATE *MGR_Sterzo_Ant_DX;
 MGROUP_ROTATE *MGR_Sterzo_Ant_SX;
 MGROUP_ROTATE *MGR_Sterzo_Post_DX;
 MGROUP_ROTATE *MGR_Sterzo_Post_SX;
 MGROUP_ROTATE **MGR_Middle;

 bool Four_Wheels_Steering;

 bool Without_Wheels;
 bool Without_Steering_Wheel;
 bool Without_Middle;


 oapi::Brush *mydarkblue;
 oapi::Pen *penblue;
 oapi::Brush *mydarkred;

 bool isMotorcycle;

 double SteerReturnFunction(double x_input, double amplitude,double zero_interval);

 double grav_acc;

 char listenfrom[256];
 bool wListener;
 void CheckListener();

 int Middle_Axles_N;

 ATTACHMENTHANDLE Towing_att;
 VECTOR3 Towing_Attachment_Pos;
 double Tow_Max_Angle;

 LightEmitter* FrontLights[2];
 LightEmitter* RearLights[2];
};



